var FocusCanv = false; // TODO: при изменении данного параметра, надо посмотреть что происходит с селектом
var KeyDown;
var MouseUp = false;

var LastClickTime = -1;
var ClickCount    = 0;
var LastMousePos = {X : 0, Y : 0};

var Para = new CParagraph(50,75);

function Actions_KeyDown(e)
{
	KeyDown = false;
	
	// Обрабатываем нажатие "enter"
	if ( e.keyCode == 13 )
	{
		if ( e.shiftKey )
		{
			Para.Add( new ParaNewLine() );
		}
		KeyDown = true;
		Para.Draw();
		return false;
	}
	// обрабатываем нажатие "backspace"
	else if ( e.keyCode == 8 )  
	{
		Para.Remove( -1, true );
		Para.Draw();
		return false;
	}
	// обрабатываем "del"
	else if ( e.keyCode == 46 )
	{
		Para.Remove( 1, true );
		Para.Draw();
		return true;
	}
	// Стрелка влево
	else if ( e.keyCode == 37 )
	{
		Target.GetHtmlElement().style.display = "block"; // Чтобы при зажатой клавише курсор не пропадал
		Para.Cursor_MoveLeft( 1, true === e.shiftKey );
		KeyDown = true;
		return true;
	}
	// Стрелка вправо
	else if ( e.keyCode == 39 )
	{
		Target.GetHtmlElement().style.display = "block"; // Чтобы при зажатой клавише курсор не пропадал
		Para.Cursor_MoveRight( 1, true === e.shiftKey );
		KeyDown = true;
		return true;
	}
	else if ( e.keyCode == 38 ) // стрелка вверх
	{
		Target.GetHtmlElement().style.display = "block"; // Чтобы при зажатой клавише курсор не пропадал
		Para.Cursor_MoveUp( 1, true === e.shiftKey );
		KeyDown = true;
		return false;
	}
	else if ( e.keyCode == 40 ) // стрелка вниз
	{
		Target.GetHtmlElement().style.display = "block"; // Чтобы при зажатой клавише курсор не пропадал
		Para.Cursor_MoveDown( 1, true === e.shiftKey );
		KeyDown = true;
		return false;
	}
	else if ( e.keyCode == 35 ) // клавиша End
	{
		Para.Cursor_MoveEndOfLine( true === e.shiftKey );
		KeyDown = true;
		return false;
	}
	else if ( e.keyCode == 36 ) // клавиша Home
	{
		Para.Cursor_MoveStartOfLine( true === e.shiftKey );
		KeyDown = true;
		return false;
	}
	
	return true;
}

function Actions_KeyPress(e)
{
	if ( true === KeyDown )
		return false;
	
	var Code;
	if ( e.charCode )
		Code = e.charCode;
	else if ( e.keyCode )
		Code = e.keyCode;
	
	if ( 0x20 == Code )
	{
		Para.Add( new ParaSpace( 1 ) );
		Para.Draw();
		return false;
	}
	if ( Code > 0x20 )
	{
		Para.Add( new ParaText( String.fromCharCode( Code ) ) );
		Para.Draw();
		return false;
	}
	
	KeyDown = true;

    return true;
}

function Actions_ParaAlign(Align)
{
	document.getElementById("ParaAlign_Left").src = "Images/alignLeft.png";
	document.getElementById("ParaAlign_Right").src = "Images/alignRight.png";
	document.getElementById("ParaAlign_Center").src = "Images/alignCenter.png";
	document.getElementById("ParaAlign_Justify").src = "Images/alignJustify.png";

	switch(Align)
	{
		case align_Left:
			document.getElementById("ParaAlign_Left").src = "Images/alignLeft_clicked.png";
			break;
		case align_Right:
			document.getElementById("ParaAlign_Right").src = "Images/alignRight_clicked.png";
			break;
		case align_Center:
			document.getElementById("ParaAlign_Center").src = "Images/alignCenter_clicked.png";
			break;
		case align_Justify:
			document.getElementById("ParaAlign_Justify").src = "Images/alignJustify_clicked.png";
			break;
	}
	
	Para.Pr.Jc = Align;
	Para.Draw();
}

function Actions_CanvasClick(e)
{
	if ( true === Para.Selection.Start )
		return;
	else if ( true === MouseUp )
	{
		MouseUp = false;
		return;
	}
	else if ( false === Para.Selection.Start && true === Para.Selection.Use )
	{
        if ( 1 == ClickCount )
        {
            Para.Selection_Remove();
            Para.Selection.Use = false;
        }
	}
	MouseUp = false;

	if ( FocusCanv === false )
	{
		FocusCanv = true;
		return;
	}
	
	var PosX = 0;
	var PosY = 0;
	if ( e.pageX || e.pageY )
 	{
		PosX = e.pageX;
		PosY = e.pageY;
	}
	else if ( e.clientX || e.clientY )
 	{
		PosX = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
		PosY = e.clientY + document.body.scrollTop  + document.documentElement.scrollTop;
	}
	var X = PosX - Canvas.GetHtmlElement().offsetLeft;
	var Y = PosY - Canvas.GetHtmlElement().offsetTop;

    var Temp = ClickCount % 2;
    if ( 1 == ClickCount )
    {
        Para.Cursor_MoveAt( X, Y );
        Para.Selection_Remove();
        Para.Selection.Use = false;
    }
    else if ( 0 == Temp )
    {
        //Para.Selection.Use = true;
        //Para.Selection_SelectWord( X, Y );
    }
    else // ( 1 == ClickCount % 3 )
    {
        // Селектим параграф целиком
        Para.Selection.StartPos = 0;
        Para.Selection.EndPos = Para.Content.length;
        Para.Selection.Use = true;

        Para.Selection_CalculateTextPr();
        Para.Selection_Draw();
    }
}
function Actions_CanvasMouseDown(e)
{
	if ( FocusCanv === false )
	{
		FocusCanv = true;
		return;
	}
	
	var PosX = 0;
	var PosY = 0;
	if ( e.pageX || e.pageY )
 	{
		PosX = e.pageX;
		PosY = e.pageY;
	}
	else if ( e.clientX || e.clientY )
 	{
		PosX = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
		PosY = e.clientY + document.body.scrollTop  + document.documentElement.scrollTop;
	}
	var X = PosX - Canvas.GetHtmlElement().offsetLeft;
	var Y = PosY - Canvas.GetHtmlElement().offsetTop;
	
	Para.Selection_SetStart( X, Y );
}
function Actions_CanvasMouseUp(e)
{
    // Считаем количество кликов по канве
    var CurTime = new Date().getTime();
    if ( 0 == ClickCount )
    {
        ClickCount = 1;
        LastClickTime = CurTime;
    }
    else
    {
        if ( 500 > CurTime - LastClickTime )
        {
            LastClickTime = CurTime;
            ClickCount++;
        }
        else
        {
            ClickCount = 1;
            LastClickTime = CurTime;
        }
    }

    var PosX = 0;
    var PosY = 0;
    if ( e.pageX || e.pageY )
    {
        PosX = e.pageX;
        PosY = e.pageY;
    }
    else if ( e.clientX || e.clientY )
    {
        PosX = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
        PosY = e.clientY + document.body.scrollTop  + document.documentElement.scrollTop;
    }
    var X = PosX - Canvas.GetHtmlElement().offsetLeft;
    var Y = PosY - Canvas.GetHtmlElement().offsetTop;

	if ( true === Para.Selection.Start )
	{
		Para.Selection.Start = false;
		MouseUp = true;

		Para.Selection_SetEnd( X, Y, true );
	}

    if ( true === Para.Selection.Use && null == Interface.FlyTextPr.Div )
    {
        Interface.FlyTextPr_Init(X,Y);
    }
}

function Actions_CanvasOnMove(e)
{
    var PosX = 0;
    var PosY = 0;
    if ( e.pageX || e.pageY )
    {
        PosX = e.pageX;
        PosY = e.pageY;
    }
    else if ( e.clientX || e.clientY )
    {
        PosX = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
        PosY = e.clientY + document.body.scrollTop  + document.documentElement.scrollTop;
    }
    var X = PosX - Canvas.GetHtmlElement().offsetLeft;
    var Y = PosY - Canvas.GetHtmlElement().offsetTop;

    if ( Math.abs( LastMousePos.X - X ) > 3 || Math.abs( LastMousePos.Y - Y ) > 3 )
    {
        ClickCount = 0;
        LastClickTime = 0;
    }

    LastMousePos.X = X;
    LastMousePos.Y = Y;

	if ( true === Para.Selection.Use && true === Para.Selection.Start )
	{

		Para.Selection_SetEnd( X, Y, false );
	}
    else if ( true === Para.Selection.Use )
    {
        Interface.FlyTextPr_SetOpacity(X,Y);
    }
}

function Actions_SetFontSize(Size)
{
	Para.Add( new ParaTextPr( { FontSize : Size } ) );
}

function Actions_SetFontFamily(Family)
{
	Para.Add( new ParaTextPr( { FontFamily : Family } ) );
}

function Actions_TextPr(Type)
{
	switch(Type)
	{
		case "Bold": 
		{
			Para.Add( new ParaTextPr( { Bold : !Interface.TextPr.Bold } ) );
			break;
		}
		case "Italic": 
		{
			Para.Add( new ParaTextPr( { Italic : !Interface.TextPr.Italic } ) );
			break;
		}
		case "Underline": 
		{
			Para.Add( new ParaTextPr( { Underline : !Interface.TextPr.Underline } ) );
			break;
		}
		case "Strikeout": 
		{
			Para.Add( new ParaTextPr( { Strikeout : !Interface.TextPr.Strikeout } ) );
			break;
		}
	}
}
function Actions_ParaLineSpacing(Value)
{
    if ( "number" != typeof(Value) )
        return;

    Para.Pr.Spacing.Line = Value;

    Para.Recalculate();
    Para.Draw();

    if ( true === Para.Selection.Use )
        Para.Selection_Draw();
};

function Actions_TestText()
{
	Para.Recalculate();
    
	var Strings = ["ONLYOFFICE. Голая правда об исходном коде облачного офиса", "", "В начале июля Teamlab переименовался в ONLYOFFICE и полностью открыл исходный код своего приложения, включая онлайн редакторы документов, совместное редактирование, диаграмму Ганта и функционал выставления счетов.",
    "За две недели мы получили массу вопросов на эту тему, поэтому на правах сотрудника компании возьмусь разъяснить, что к чему. Если у вас нет времени читать пост, просто скачайте инсталляцию ONLYOFFICE с Sourceforge. Разверните на своем сервере. Готово! У вас есть свой облачный офис. Вы великолепны.", "",
    "Почему Teamlab стал ONLYOFFICE", "", "Идея ребрендинга существовала довольно давно. В своем блоге мы написали целый пост о том, почему мы выбрали ONLY в качестве новой приставки к своему офису, однако, были и вполне конкретные причины. Во-первых, название Teamlab перестало отражать идею продукта, ведь \"team\" ассоциируется с небольшой командой, в то время как среди наших клиентов все чаще появляются компании по 300 и 400 человек. Во-вторых, помимо нас, к сожалению,слово облюбовали дизайнеры интерактивных вешалок из Японии.", "",
    "Почему мы открыли исходный код (Honesty is the best policy потому что)", "", "Основная причина - это, безусловно, доверие. Не только со стороны клиентов, но и со стороны наших партнеров. В сегодняшней ситуации мы получаем довольно много вопросов о безопасности хранения корпоративных данных, особенно от зарубежных клиентов. Публикуя код ONLYOFFICE на Sourceforge и GitHub, мы делаем еще один шаг им навстречу."];
	
	for ( var i = 0; i < Strings.length; i++ )
	{
		switch ( i )
		{
			case 0 : Para.Add( new ParaTextPr( { FontSize : 18, FontFamily : "Arial", Bold : true } ) ); break;
            case 5 :
            case 9 : Para.Add( new ParaTextPr( { FontSize : 14, FontFamily : "Arial", Bold : true } ) ); break;
			default: Para.Add( new ParaTextPr( { FontSize : 12, FontFamily : "Arial", Bold : false } ) ); break;
		}
		for ( var Index = 0; Index < Strings[i].length; Index++ )
		{
			Para.Add( new ParaText( Strings[i].charAt( Index ) ), false );
		}
		Para.Add( new ParaNewLine());
	}
	Para.Recalculate();
	Para.Draw();
}