var Default_FontSize   = 14;
var Default_FontFamily = "Arial";


var para_SetFont = 0x0100; // Устанавливаем шрифт

var align_Right   = 0;
var align_Left    = 1;
var align_Center  = 2;
var align_Justify = 3;

var linerule_AtLeast = 0;
var linerule_Auto    = 1;
var linerule_Exact   = 2;

// Класс Paragraph
function CParagraph(X,Y)
{
	this.X = X;
	this.Y = Y;
	this.XLimit = 547;
	
	this.Pr = new Object();
	this.Pr.Jc = align_Left;
	this.Pr.Spacing = 
	{
		Line     : 1.15,
		LineRule : linerule_Auto,
	}
	
	this.Lines   = new Array();
	
	// Добавляем в контент элемент "конец параграфа"
	this.Content = new Array();
	this.Content.push( new ParaEnd() );
	
	this.CurPos  = 
	{
		X          : 0,
		Y          : 0,
		ContentPos : 0,
		ItemPos    : 0,
		RealX      : 0, // позиция курсора, без учета расположения букв
		RealY      : 0  // это актуально для клави вверх и вниз
	};
	
	this.Selection = 
	{
		Start    : false,
		Use      : false,
		StartPos : 0,
		EndPos   : 0,

		SelectIds: []
	};
}

CParagraph.prototype.Recalculate = function()
{
	var CurTextPr = 
	{
		Bold       : Default_TextPr_Bold,
		Italic     : Default_TextPr_Italic,
		Underline  : Default_TextPr_Underline,
		Strikeout  : Default_TextPr_Strikeout,
		FontFamily : Default_TextPr_FontFamily,
		FontSize   : Default_TextPr_FontSize,
	};
	
	Canvas.SetFont( CurTextPr );
	
	var X = this.X, Y = this.Y; // Смещаемся в начало параграфа
	
	// Удаляем ранее рассчитанные переносы строк
	for ( var nPos = 0; nPos < this.Content.length; nPos++ )
	{
		var Item = this.Content[nPos];
		if ( Item.Type == para_NewLineRendered )
		{
			// Текущая позиция смещается
			if ( this.CurPos.ContentPos > nPos )
				this.CurPos.ContentPos--;

			if ( this.Selection.StartPos >= nPos )
				this.Selection.StartPos--;

			if ( this.Selection.EndPos >= nPos )
				this.Selection.EndPos--;
			
			this.Content.splice( nPos, 1 );
			nPos--;
		}
		// Объединяем несколько подряд идущиз TextPr (но только если на втором не стоит текущая позиция)
		else if ( Item.Type == para_TextPr && nPos > 0 && this.Content[nPos - 1].Type == para_TextPr && nPos != this.CurPos.ContentPos )
		{
			for ( var Pr in Item.Value )
				this.Content[nPos - 1].Value[Pr] = Item.Value[Pr];
			
			// Текущая позиция смещается
			if ( this.CurPos.ContentPos > nPos )
				this.CurPos.ContentPos--;

			if ( this.Selection.StartPos >= nPos )
				this.Selection.StartPos--;

			if ( this.Selection.EndPos >= nPos )
				this.Selection.EndPos--;
			
			this.Content.splice( nPos, 1 );
			nPos--
		}
	}
	
	// Делаем новый пересчет
	var bNewLine = false;
	var bFirstItemOnLine = true;
	var CurLine = 0;
	var bWord = false;
	var nWordStartPos = 0;
	var nWordLen = 0;
	var nWordH = 0;
	this.Lines.length = 0;
	
	this.Lines[CurLine] = new Object();
	this.Lines[CurLine].Y = 0;
	this.Lines[CurLine].H = 1.3 * CurTextPr.FontSize;

	for ( var nPos = 0; nPos < this.Content.length; nPos++ )
	{
		if ( nPos == this.CurPos.ContentPos )
		{
			this.CurPos.X = X + nWordLen;
			this.CurPos.Y = Y;
			
			Target.Update( X + nWordLen, Y );
			Target.SetSize( CurTextPr.FontSize );
		}
		
		var Item = this.Content[nPos];
		
		switch( Item.Type )
		{
			case para_Text:
				
				// TO DO: Перелать рассчет высоты слова
				if ( CurTextPr.FontSize * 1.3 > nWordH )
					nWordH  = CurTextPr.FontSize * 1.3;

				if ( !bWord )
				{
					// Если слово только началось, и до него на строке ничего не было, тогда не надо проверять убирается ли оно на строке.
					var LetterLen = Item.Measure( Canvas ).Width;
					if ( !bFirstItemOnLine )
					{
						if ( X + LetterLen > this.XLimit )
						{
							// Смещаемся к началу слова, и перед ним ставим перенос строки
							this.Content.splice( nPos, 0, new ParaNewLineRendered() );
							bNewLine = true;
							
							if ( this.CurPos.ContentPos >= nPos )
								this.CurPos.ContentPos++;
							if ( this.Selection.StartPos >= nPos )
								this.Selection.StartPos++;
							if ( this.Selection.EndPos >= nPos )
								this.Selection.EndPos++;
						}
					}
						
					if ( !bNewLine )
					{
						nWordStartPos = nPos;
						nWordLen = Item.Measure( Canvas ).Width;
						bWord = true;
						
						if ( "undefined" == typeof(this.Lines[CurLine].Words) )
							this.Lines[CurLine].Words = 1;
						else
							this.Lines[CurLine].Words++;
					}
				}
				else
				{
					var LetterLen = Item.Measure( Canvas ).Width;
					if ( X + nWordLen + LetterLen > this.XLimit )
					{
						if ( bFirstItemOnLine )
						{
							// Слово оказалось единственным элементом строки, и, все равно,
							// не умещается целиком. Ставим перенос строки на текущей позиции.
							X += nWordLen;
							this.Content.splice( nPos, 0, new ParaNewLineRendered() );
							if ( this.CurPos.ContentPos >= nPos )
								this.CurPos.ContentPos++;
							if ( this.Selection.StartPos >= nPos )
								this.Selection.StartPos++;
							if ( this.Selection.EndPos >= nPos )
								this.Selection.EndPos++;

							bNewLine = true;
							if ( nWordH > this.Lines[CurLine].H )
								this.Lines[CurLine].H = nWordH;
						}
						else
						{
							// Смещаемся к началу слова, и перед ним ставим перенос строки
							this.Content.splice( nWordStartPos, 0, new ParaNewLineRendered() );
							nPos = nWordStartPos;
							if ( this.CurPos.ContentPos >= nWordStartPos )
								this.CurPos.ContentPos++;
							if ( this.Selection.StartPos >= nWordStartPos )
								this.Selection.StartPos++;
							if ( this.Selection.EndPos >= nWordStartPos )
								this.Selection.EndPos++;

							bNewLine = true;
							this.Lines[CurLine].Words--;
						}
					}
					
					if ( !bNewLine )
					{
						nWordLen += LetterLen;
					}
				}
				break;
			case para_Space:
				
				bFirstItemOnLine = false;
				var SpaceLen = Item.Measure( Canvas ).Width;
				if ( bWord )
				{
					if ( nWordH > this.Lines[CurLine].H )
						this.Lines[CurLine].H = nWordH;
					
					// Не надо проверять убирается ли слово, мы это проверяем при добавленнии букв
					X += nWordLen;
					
					bWord = false;
					nWordLen = 0;
				}
				
				nWordH   = 0;
				
				if ( X + SpaceLen > this.XLimit )
				{
					this.Content.splice( nPos, 0, new ParaNewLineRendered() );
					if ( this.CurPos.ContentPos >= nPos )
						this.CurPos.ContentPos++;
					if ( this.Selection.StartPos >= nPos )
						this.Selection.StartPos++;
					if ( this.Selection.EndPos >= nPos )
						this.Selection.EndPos++;
					
					bNewLine = true;
				}
				else
					X += SpaceLen;
				break;
				
			case para_TextPr:
				
				for (var Prop in Item.Value)
				{
					CurTextPr[Prop] = Item.Value[Prop];
				}
				Canvas.SetFont( CurTextPr );
				break;
				
			case para_NewLine:

				if ( nWordH > this.Lines[CurLine].H )
					this.Lines[CurLine].H = nWordH;
				
				X += nWordLen;
				
				bNewLine = true;
				break;
			case para_End:
				if ( nWordH > this.Lines[CurLine].H )
					this.Lines[CurLine].H = nWordH;
				
				X += nWordLen;
				
				this.Lines[CurLine].W = X - this.X;
				if (CurLine > 0 )
				{
					Y += (0.23 * this.Lines[CurLine-1].H / 1.3 + this.Lines[CurLine].H / 1.3) * this.Pr.Spacing.Line;
					this.Lines[CurLine].Y = Y - this.Y;
				}
				
				break;
		}
		
		// При переходе на новую строку прибавляем оставшийся контент в начало следующей строки
		if ( bNewLine )
		{
			bNewLine = false;
			bFirstItemOnLine = true;
			this.Lines[CurLine].W = X - this.X;
			
			X = this.X;
			
			if (CurLine > 0 )
			{
				Y += (0.23 * this.Lines[CurLine-1].H / 1.3 + this.Lines[CurLine].H / 1.3) * this.Pr.Spacing.Line;
				this.Lines[CurLine].Y = Y - this.Y;
			}

			CurLine++;
			this.Lines[CurLine] = new Object();
			bWord = false;
			nWordLen = 0;
			nWordH   = 0;
			
			this.Lines[CurLine].H = CurTextPr.FontSize * 1.3;
		}
	}
}
CParagraph.prototype.RecalculateCurPos = function()
{
	var CurTextPr = 
	{
		Bold       : Default_TextPr_Bold,
		Italic     : Default_TextPr_Italic,
		Underline  : Default_TextPr_Underline,
		Strikeout  : Default_TextPr_Strikeout,
		FontFamily : Default_TextPr_FontFamily,
		FontSize   : Default_TextPr_FontSize,
	};
	
	Canvas.SetFont( CurTextPr );
	
	var Y = this.Y;
	var CurLine = 0;
	var LineWidth = this.XLimit - this.X;

	var X = 0;
	var JustifySpace = 0;

	switch (this.Pr.Jc)
	{
		case align_Left   : X = this.X; break;
		case align_Right  : X = this.X + LineWidth - this.Lines[0].W; break;
		case align_Center : X = this.X + (LineWidth - this.Lines[0].W) / 2; break
		case align_Justify: 
			{
				X = this.X; 
				if ( this.Lines[0].Words > 1 )
					JustifySpace = (LineWidth - this.Lines[0].W) / ( this.Lines[0].Words - 1); 
				else
					JustifySpace = 0;
				break;
			}
		default : X = this.X; break;
	}
	
	var bWord = false;
	var nWords = this.Lines[0].Words - 1;
	
	for ( var ItemNum = 0; ItemNum < this.Content.length; ItemNum++ )
	{
		if ( ItemNum == this.CurPos.ContentPos )
		{
			this.CurPos.X = X;
			this.CurPos.Y = Y;
			
			Target.SetSize( CurTextPr.FontSize );
			Target.Update( X, Y );
		}
		
		var Item = this.Content[ItemNum];
		
		switch( Item.Type )
		{
			case para_Text:
				if ( !bWord )
					bWord = true;
				X += Item.Width;
				break;
			case para_Space:
				if ( bWord )
				{
					bWord = false;
					if ( nWords > 0 )
					{
						X += JustifySpace;
						nWords--;
					}
				}
				X += Item.Width;
				break;
			case para_TextPr:
				
				for (var Prop in Item.Value)
				{
					CurTextPr[Prop] = Item.Value[Prop];
				}
				Canvas.SetFont( CurTextPr );
				break;

			case para_End:
				X += Item.Width;
				break;
			case para_NewLine:
				
				X += Item.Width;
				
				// break специально не ставим
			case para_NewLineRendered:
			
				Y += (0.23 * this.Lines[CurLine].H / 1.3 + this.Lines[CurLine + 1].H / 1.3) * this.Pr.Spacing.Line;
				
				CurLine++;
				Y = this.Y + this.Lines[CurLine].Y;
				bWord = false;
				switch (this.Pr.Jc)
				{
					case align_Left   : X = this.X; break;
					case align_Right  : X = this.X + LineWidth - this.Lines[CurLine].W; break;
					case align_Center : X = this.X + (LineWidth - this.Lines[CurLine].W) / 2; break
					case align_Justify:
						{
							X = this.X; 
							if ( this.Lines[CurLine].Words > 1 )
								JustifySpace = (LineWidth - this.Lines[CurLine].W) / ( this.Lines[CurLine].Words - 1); 
							else
								JustifySpace = 0;
							break;
						}
				}
				nWords = this.Lines[CurLine].Words - 1;
				break;
		}
		if ( Y > 842 )
			break;
	}
}
CParagraph.prototype.Draw = function()
{
	var CurTextPr = 
	{
		Bold       : Default_TextPr_Bold,
		Italic     : Default_TextPr_Italic,
		Underline  : Default_TextPr_Underline,
		Strikeout  : Default_TextPr_Strikeout,
		FontFamily : Default_TextPr_FontFamily,
		FontSize   : Default_TextPr_FontSize,
	};
	
	Canvas.Clear();
	Canvas.SetFont( CurTextPr );
	Canvas.SetFillStyle( "rgb(0,0,0)" );
	
	var Y = this.Y;
	var CurLine = 0;
	var LineWidth = this.XLimit - this.X;

	var X = 0;
	var JustifySpace = 0;

	switch (this.Pr.Jc)
	{
		case align_Left   : X = this.X; break;
		case align_Right  : X = this.X + LineWidth - this.Lines[0].W; break;
		case align_Center : X = this.X + (LineWidth - this.Lines[0].W) / 2; break
		case align_Justify: 
			{
				X = this.X; 
				if ( this.Lines[0].Words > 1 )
					JustifySpace = (LineWidth - this.Lines[0].W) / ( this.Lines[0].Words - 1); 
				else
					JustifySpace = 0;
				break;
			}
		default : X = this.X; break;
	}
	
	var bWord = false;
	var nWords = this.Lines[0].Words - 1;
	
	for ( var ItemNum = 0; ItemNum < this.Content.length; ItemNum++ )
	{
		if ( ItemNum == this.CurPos.ContentPos )
		{
			this.CurPos.X = X;
			this.CurPos.Y = Y;
			
			Target.SetSize( CurTextPr.FontSize );
			Target.Update( X, Y );
		}
		var Item = this.Content[ItemNum];
		
		switch( Item.Type )
		{
			case para_Text:
				if ( !bWord )
					bWord = true;
				Item.Draw( X, Y, Canvas );
				if ( true === CurTextPr.Strikeout )
				{
					Canvas.SetLineWidth( CurTextPr.FontSize / 22 + 1 );
					Canvas.BeginPath();
					Canvas.MoveTo( X, Y - CurTextPr.FontSize / 2 + CurTextPr.FontSize * 0.1 );
					Canvas.LineTo( X + Item.Width, Y - CurTextPr.FontSize / 2 + CurTextPr.FontSize * 0.1 );
					Canvas.Stroke();
				}

				if ( true === CurTextPr.Underline )
				{
					Canvas.SetLineWidth( CurTextPr.FontSize / 22 + 1 );
					Canvas.BeginPath();
					Canvas.MoveTo( X, Y + this.Lines[CurLine].H * 0.1 );
					Canvas.LineTo( X + Item.Width, Y + this.Lines[CurLine].H * 0.1 );
					Canvas.Stroke();
				}

				X += Item.Width;
				break;
			case para_Space:
				if ( bWord )
				{
					bWord = false;
					if ( nWords > 0 )
					{
						X += JustifySpace;
						nWords--;
					}
				}
				Item.Draw( X, Y, Canvas );

				if ( true === CurTextPr.Strikeout )
				{
					Canvas.LineWidth = CurTextPr.FontSize / 22 + 1;
					Canvas.BeginPath();
					Canvas.MoveTo( X, Y - CurTextPr.FontSize / 2 + CurTextPr.FontSize * 0.1 );
					Canvas.LineTo( X + Item.Width, Y - CurTextPr.FontSize / 2 + CurTextPr.FontSize * 0.1 );
					Canvas.Stroke();
				}

				if ( true === CurTextPr.Underline )
				{
					Canvas.SetLineWidth( CurTextPr.FontSize / 22 + 1 );
					Canvas.BeginPath();
					Canvas.MoveTo( X, Y + this.Lines[CurLine].H * 0.1 );
					Canvas.LineTo( X + Item.Width, Y + this.Lines[CurLine].H * 0.1 );
					Canvas.Stroke();
				}

				X += Item.Width;
				break;
			case para_TextPr:
				
				for (var Prop in Item.Value)
				{
					CurTextPr[Prop] = Item.Value[Prop];
				}
				Canvas.SetFont( CurTextPr );
				break;

			case para_End:
				Item.Draw( X, Y, Canvas );
				X += Item.Width;
				break;
			case para_NewLine:
				
				Item.Draw( X, Y, Canvas );
				X += Item.Width;
				
				// break специально не ставим
			case para_NewLineRendered:
			
				Y += (0.23 * this.Lines[CurLine].H / 1.3 + this.Lines[CurLine + 1].H / 1.3) * this.Pr.Spacing.Line;
				
				CurLine++;
				Y = this.Y + this.Lines[CurLine].Y;
				bWord = false;
				switch (this.Pr.Jc)
				{
					case align_Left   : X = this.X; break;
					case align_Right  : X = this.X + LineWidth - this.Lines[CurLine].W; break;
					case align_Center : X = this.X + (LineWidth - this.Lines[CurLine].W) / 2; break
					case align_Justify:
						{
							X = this.X; 
							if ( this.Lines[CurLine].Words > 1 )
								JustifySpace = (LineWidth - this.Lines[CurLine].W) / ( this.Lines[CurLine].Words - 1); 
							else
								JustifySpace = 0;
							break;
						}
				}
				nWords = this.Lines[CurLine].Words - 1;
				break;
		}
		if ( Y > 842 )
			break;
	}
}
// Удаляем элементы параграфа
// nCount - количество удаляемых элементов, > 0 удаляем элементы после курсора
//                                          < 0 удаляем элементы до курсора
// bOnlyText - true: удаляем только текст и пробелы, false - Удаляем любые элементы
CParagraph.prototype.Remove  = function(nCount, bOnlyText)
{
	// Сначала проверим имеется ли у нас селект
	if ( true === this.Selection.Use )
	{
		var StartPos = this.Selection.StartPos;
		var EndPos   = this.Selection.EndPos;
		
		if ( StartPos > EndPos )
		{
			var Temp = EndPos;
			EndPos   = StartPos;
			StartPos = Temp;
		}
		
		// Рассчитаем стиль на конце селекта
		var TextPr = this.Internal_CalculateTextPr( EndPos + 1 );
		this.Content.splice( StartPos, EndPos - StartPos, new ParaTextPr( TextPr ) );
		this.CurPos.ContentPos = StartPos;
		this.Recalculate();

		this.Selection_Remove();
		return;
	}
	
	if ( 0 == nCount )
		return;
	
	var absCount = ( nCount < 0 ? -nCount : nCount );
	
	for ( var Index = 0; Index < absCount; Index++ )
	{
		if ( nCount < 0 )
			this.Internal_RemoveBackward(bOnlyText);
		else
			this.Internal_RemoveForward(bOnlyText);
	}
	
	try
	{
		var TextPr = this.Internal_CalculateTextPr( this.CurPos.ContentPos );
		Interface.UpdateTextPr( TextPr );
	}
	catch(e)
	{
		
	}
	
	// TO DO: Переcчитываем параграф
	this.Recalculate();
}
CParagraph.prototype.Internal_RemoveBackward = function(bOnlyText)
{
	var Line = this.Content;
	var CurPos = this.CurPos.ContentPos;
	
	if ( !bOnlyText )
	{
		if ( CurPos == 0 )
			return;
		else 
		{
			// Просто удаляем элемент предстоящий текущей позиции и уменьшаем текущую позицию
			Line.splice( CurPos - 1, 1 );
			this.CurPos.ContentPos--;
		}
	}
	else
	{
		var LetterPos = CurPos - 1;
		
		var oPos = this.Internal_FindBackward( LetterPos, [para_Text, para_Space, para_NewLine] );
		
		if ( oPos.Found )
		{
			// Удаляем элемент в найденной позиции и уменьшаем текущую позицию
			this.Content.splice( oPos.LetterPos, 1 );
			this.CurPos.ContentPos = oPos.LetterPos;
		}
		else
		{
			// Ничего не делаем
		}
	}
}
	
CParagraph.prototype.Internal_RemoveForward  = function(bOnlyText)
{
	var Line = this.Content;
	var CurPos = this.CurPos.ContentPos;
	
	if ( !bOnlyText )
	{
		if ( CurPos == Line.length - 1 )
		{
			return;
		}
		else 
		{
			// Просто удаляем элемент после текущей позиции
			Line.splice( CurPos + 1, 1 );
		}
	}
	else
	{
		var LetterPos = CurPos;
		
		var oPos = this.Internal_FindForward( LetterPos, [para_Text, para_Space, para_NewLine] );
		
		if ( oPos.Found )
		{
			// Удаляем элемент в найденной позиции и меняем текущую позицию
			this.Content.splice( oPos.LetterPos, 1 );
			this.CurPos.ContentPos = oPos.LetterPos;
		}
		else
		{
			// Ничего не делаем
		}
	}
}

// Ищем первый элемент, при промотке вперед
CParagraph.prototype.Internal_FindForward = function(CurPos, arrId)
{
	var LetterPos = CurPos;
	var bFound = false;
	var Type = para_Unknown;
	
	if ( CurPos < 0 || CurPos >= this.Content.length )
		return { Found : false };
	
	while ( !bFound )
	{
		Type = this.Content[LetterPos].Type;
		
		for ( var Id = 0; Id < arrId.length; Id++ )
		{
			if ( arrId[Id] == Type )
			{
				bFound = true;
				break;
			}
		}
		
		if ( bFound )
			break;
		
		LetterPos++;
		if ( LetterPos > this.Content.length - 1 )
			break;
	}
	
	return { LetterPos : LetterPos, Found : bFound, Type : Type };
}

// Ищем первый элемент, при промотке назад
CParagraph.prototype.Internal_FindBackward = function(CurPos, arrId)
{
	var LetterPos = CurPos;
	var bFound = false;
	var Type = para_Unknown;
	
	if ( CurPos < 0 || CurPos >= this.Content.length )
		return { Found : false };
	
	while ( !bFound )
	{
		Type = this.Content[LetterPos].Type;
		for ( var Id = 0; Id < arrId.length; Id++ )
		{
			if ( arrId[Id] == Type )
			{
				bFound = true;
				break;
			}
		}

		if ( bFound )
			break;
		
		LetterPos--;
		if ( LetterPos < 0 )
			break;
	}
	
	return { LetterPos : LetterPos, Found : bFound, Type : Type };
}

CParagraph.prototype.Internal_CalculateTextPr = function (LetterPos)
{
	// Выставляем значения по умолчанию
	var TextPrCount = 6;
	var FoundTextPr = {
		Bold : 
		{
			Value : Default_TextPr_Bold,
			Found : false
		},
		Italic : 
		{
			Value : Default_TextPr_Italic,
			Found : false
		},
		Underline : 
		{
			Value : Default_TextPr_Underline,
			Found : false
		},
		Strikeout : 
		{
			Value : Default_TextPr_Strikeout,
			Found : false
		},
		FontFamily : 
		{
			Value : Default_TextPr_FontFamily,
			Found : false
		},
		FontSize : 
		{
			Value : Default_TextPr_FontSize,
			Found : false
		}
	};
	
	LetterPos++;

	while( TextPrCount > 0 )
	{
		LetterPos--;
		if ( LetterPos < 0 )
			break;
		
		// Ищем предыдущие записи с изменением текстовых свойств
		var Pos = this.Internal_FindBackward( LetterPos, [para_TextPr] );
		
		if ( Pos.Found )
		{
			var TextPr = this.Content[Pos.LetterPos].Value;
			for ( var Item in TextPr )
			{
				if ( !FoundTextPr[Item].Found )
				{
					FoundTextPr[Item].Value = TextPr[Item];
					FoundTextPr[Item].Found = true;
					TextPrCount--;
				}
			}
			
			LetterPos = Pos.LetterPos;
		}
		else
			break;
	}
	
	return { 
		Bold       : FoundTextPr.Bold.Value, 
		Italic     : FoundTextPr.Italic.Value,
		Underline  : FoundTextPr.Underline.Value,
		Strikeout  : FoundTextPr.Strikeout.Value,
		FontFamily : FoundTextPr.FontFamily.Value,
		FontSize   : FoundTextPr.FontSize.Value
	};
}

// Добавляем новый элемент к содержимому параграфа (на текущую позицию)
CParagraph.prototype.Add = function(Item, bRecalc)
{
	var Line   = this.Content;
	var CurPos = this.CurPos.ContentPos;
	
	switch (Item.Type)
	{
		case para_Text:
		{
			if ( true === this.Selection.Use )
			{
				this.Remove();
				CurPos = this.CurPos.ContentPos;
			}
			
			if ( ' ' == Item.Value )
				Line.splice( CurPos, 0, new ParaSpace() );
			else
				Line.splice( CurPos, 0, Item );
			
			this.CurPos.ContentPos++;
			
			break;
		}
		case para_Space:
		{
			if ( true === this.Selection.Use )
			{
				this.Remove();
				CurPos = this.CurPos.ContentPos;
			}

			Line.splice( CurPos, 0, Item );
			this.CurPos.ContentPos++;
			
			break;
		}
		case para_TextPr:
		{
			this.Internal_AddTextPr( Item.Value );
			break;
		}
		default:
		{
			Line.splice( CurPos, 0, Item );
			this.CurPos.ContentPos++;
			
			break;
		}
	}
	
	// Пересчитываем параграф
	if ( "undefined" == typeof(bRecalc) || true == bRecalc )
		this.Recalculate();
}
CParagraph.prototype.Cursor_MoveLeft = function(Count, AddToSelect)
{
	if ( this.CurPos.ContentPos < 0 )
		return false;
	
	if ( 0 == Count || !Count )
		return;

	var absCount = ( Count < 0 ? -Count : Count );
	
	for ( var Index = 0; Index < absCount; Index++ )
	{
		this.Internal_MoveCursorBackward(AddToSelect);
	}
	
	if ( true != this.Selection.Use )
	{
		// После перемещения курсора мы должны обновить запись о шрифте
		var TextPr = this.Internal_CalculateTextPr( this.CurPos.ContentPos );
		Interface.UpdateTextPr( TextPr );
	}

	this.RecalculateCurPos();
	
	this.CurPos.RealX = this.CurPos.X;
	this.CurPos.RealY = this.CurPos.Y;
}
CParagraph.prototype.Cursor_MoveRight = function(Count,AddToSelect)
{
	if ( this.CurPos.ContentPos < 0 )
		return false;
	
	if ( 0 == Count || !Count )
		return;

	var absCount = ( Count < 0 ? -Count : Count );
	
	for ( var Index = 0; Index < absCount; Index++ )
	{
		this.Internal_MoveCursorForward(AddToSelect);
	}
	
	if ( true != this.Selection.Use )
	{
		// После перемещения курсора мы должны обновить запись о шрифте
		var TextPr = this.Internal_CalculateTextPr( this.CurPos.ContentPos );
		Interface.UpdateTextPr( TextPr );
	}

	this.RecalculateCurPos();

	this.CurPos.RealX = this.CurPos.X;
	this.CurPos.RealY = this.CurPos.Y;
}

CParagraph.prototype.Cursor_MoveUp = function(Count, AddToSelect)
{
	if ( this.CurPos.ContentPos < 0 )
		return false;
	
	if ( !Count || 0 == Count )
		return;
	
	var absCount = ( Count < 0 ? -Count : Count );
	
	// Пока сделаем для Count = 1
	var CurLine = 0;
	for ( var Pos = this.CurPos.ContentPos - 1; Pos >= 0; Pos-- )
	{
		if ( para_NewLine == this.Content[Pos].Type || para_NewLineRendered == this.Content[Pos].Type )
			CurLine++;
	}

    if ( true === this.Selection.Use )
    {
        if ( true === AddToSelect )
        {
            this.CurPos.ContentPos = this.Selection.EndPos;

            // Пока сделаем для Count = 1
            var CurLine = 0;
            for ( var Pos = this.CurPos.ContentPos - 1; Pos >= 0; Pos-- )
            {
                if ( para_NewLine == this.Content[Pos].Type || para_NewLineRendered == this.Content[Pos].Type )
                    CurLine++;
            }

            this.RecalculateCurPos();
            this.CurPos.RealX = this.CurPos.X;
            this.CurPos.RealY = this.CurPos.Y;

            if ( 0 == CurLine )
            {
                // TODO: надо перейти в предыдущий элемент документы

                this.Selection.EndPos = 0;
            }
            else
            {
                this.Cursor_MoveAt( this.CurPos.RealX, CurLine - 1, true, true );
                this.CurPos.RealY = this.CurPos.Y;
                this.Selection.EndPos = this.CurPos.ContentPos;
            }

            if ( this.Selection.StartPos == this.Selection.EndPos )
            {
                this.Selection_Remove();
                this.Selection.Use = false;

                this.CurPos.ContentPos = this.Selection.EndPos;
                this.RecalculateCurPos();

                // После перемещения курсора мы должны обновить запись о шрифте
                var TextPr = this.Internal_CalculateTextPr( this.CurPos.ContentPos );
                Interface.UpdateTextPr( TextPr );
                // Возвращаем курсор
                Target.Drawing_Init();

                return;
            }

            // Убираем курсор
            Target.Drawing_Remove();

            this.Selection_CalculateTextPr();
            this.Selection_Draw();
        }
        else
        {
            var StartPos = this.Selection.StartPos;
            var EndPos   = this.Selection.EndPos;

            if ( StartPos > EndPos )
            {
                var Temp = EndPos;
                EndPos   = StartPos;
                StartPos = Temp;
            }

            this.CurPos.ContentPos = StartPos;
            this.Selection_Remove();

            // Пока сделаем для Count = 1
            var CurLine = 0;
            for ( var Pos = this.CurPos.ContentPos - 1; Pos >= 0; Pos-- )
            {
                if ( para_NewLine == this.Content[Pos].Type || para_NewLineRendered == this.Content[Pos].Type )
                    CurLine++;
            }

            this.RecalculateCurPos();
            this.CurPos.RealX = this.CurPos.X;
            this.CurPos.RealY = this.CurPos.Y;

            if ( 0 == CurLine )
            {
                // TODO: надо перейти в предыдущий элемент документы
            }
            else
            {
                this.Cursor_MoveAt( this.CurPos.RealX, CurLine - 1, true, true );
                this.CurPos.RealY = this.CurPos.Y;
            }

        }
    }
    else if ( true === AddToSelect )
    {
        this.Selection.Use = true;
        this.Selection.StartPos = this.CurPos.ContentPos;

        // Пока сделаем для Count = 1
        var CurLine = 0;
        for ( var Pos = this.CurPos.ContentPos - 1; Pos >= 0; Pos-- )
        {
            if ( para_NewLine == this.Content[Pos].Type || para_NewLineRendered == this.Content[Pos].Type )
                CurLine++;
        }

        this.RecalculateCurPos();
        this.CurPos.RealX = this.CurPos.X;
        this.CurPos.RealY = this.CurPos.Y;

        if ( 0 == CurLine )
        {
            // TODO: надо перейти в предыдущий элемент документы

            this.Selection.EndPos = 0;
        }
        else
        {
            this.Cursor_MoveAt( this.CurPos.RealX, CurLine - 1, true, true );
            this.CurPos.RealY = this.CurPos.Y;
            this.Selection.EndPos = this.CurPos.ContentPos;
        }

        if ( this.Selection.StartPos == this.Selection.EndPos )
        {
            this.Selection_Remove();
            this.Selection.Use = false;

            this.CurPos.ContentPos = this.Selection.EndPos;
            this.RecalculateCurPos();

            // После перемещения курсора мы должны обновить запись о шрифте
            var TextPr = this.Internal_CalculateTextPr( this.CurPos.ContentPos );
            Interface.UpdateTextPr( TextPr );
            // Возвращаем курсор
            Target.Drawing_Init();

            return;
        }

        // Убираем курсор
        Target.Drawing_Remove();

        this.Selection_CalculateTextPr();
        this.Selection_Draw();
    }
	else
    {
        if ( 0 == CurLine )
        {
            // TODO: надо перейти в предыдущий элемент документы
        }
        else
        {
            this.Cursor_MoveAt( this.CurPos.RealX, CurLine - 1, true, true );
            this.CurPos.RealY = this.CurPos.Y;
        }
    }
}
CParagraph.prototype.Cursor_MoveDown = function(Count, AddToSelect)
{
	if ( this.CurPos.ContentPos < 0 )
		return false;
	
	if ( !Count || 0 == Count )
		return;
	
	var absCount = ( Count < 0 ? -Count : Count );
	
	// Пока сделаем для Count = 1
	var CurLine = 0;
	for ( var Pos = this.CurPos.ContentPos - 1; Pos >= 0; Pos-- )
	{
		if ( para_NewLine == this.Content[Pos].Type || para_NewLineRendered == this.Content[Pos].Type )
			CurLine++;
	}

    if ( true === this.Selection.Use )
    {
        if ( true === AddToSelect )
        {
            this.CurPos.ContentPos = this.Selection.EndPos;

            // Пока сделаем для Count = 1
            var CurLine = 0;
            for ( var Pos = this.CurPos.ContentPos - 1; Pos >= 0; Pos-- )
            {
                if ( para_NewLine == this.Content[Pos].Type || para_NewLineRendered == this.Content[Pos].Type )
                    CurLine++;
            }

            this.RecalculateCurPos();
            this.CurPos.RealX = this.CurPos.X;
            this.CurPos.RealY = this.CurPos.Y;

            if ( this.Lines.length - 1 == CurLine )
            {
                // TODO: надо перейти в предыдущий элемент документы

                this.Selection.EndPos = this.Content.length - 1;
            }
            else
            {
                this.Cursor_MoveAt( this.CurPos.RealX, CurLine + 1, true, true );
                this.CurPos.RealY = this.CurPos.Y;
                this.Selection.EndPos = this.CurPos.ContentPos;
            }

            if ( this.Selection.StartPos == this.Selection.EndPos )
            {
                this.Selection_Remove();
                this.Selection.Use = false;

                this.CurPos.ContentPos = this.Selection.EndPos;
                this.RecalculateCurPos();

                // После перемещения курсора мы должны обновить запись о шрифте
                var TextPr = this.Internal_CalculateTextPr( this.CurPos.ContentPos );
                Interface.UpdateTextPr( TextPr );
                // Возвращаем курсор
                Target.Drawing_Init();

                return;
            }

            // Убираем курсор
            Target.Drawing_Remove();

            this.Selection_CalculateTextPr();
            this.Selection_Draw();
        }
        else
        {
            var StartPos = this.Selection.StartPos;
            var EndPos   = this.Selection.EndPos;

            if ( StartPos > EndPos )
            {
                var Temp = EndPos;
                EndPos   = StartPos;
                StartPos = Temp;
            }

            this.CurPos.ContentPos = EndPos;
            this.Selection_Remove();

            // Пока сделаем для Count = 1
            var CurLine = 0;
            for ( var Pos = this.CurPos.ContentPos - 1; Pos >= 0; Pos-- )
            {
                if ( para_NewLine == this.Content[Pos].Type || para_NewLineRendered == this.Content[Pos].Type )
                    CurLine++;
            }

            this.RecalculateCurPos();
            this.CurPos.RealX = this.CurPos.X;
            this.CurPos.RealY = this.CurPos.Y;

            if ( this.Lines.length - 1 == CurLine )
            {
                // TODO: надо перейти в следующий элемент документы
            }
            else
            {
                this.Cursor_MoveAt( this.CurPos.RealX, CurLine + 1, true, true );
                this.CurPos.RealY = this.CurPos.Y;
            }

        }
    }
    else if ( AddToSelect )
    {
        this.Selection.Use = true;
        this.Selection.StartPos = this.CurPos.ContentPos;

        // Пока сделаем для Count = 1
        var CurLine = 0;
        for ( var Pos = this.CurPos.ContentPos - 1; Pos >= 0; Pos-- )
        {
            if ( para_NewLine == this.Content[Pos].Type || para_NewLineRendered == this.Content[Pos].Type )
                CurLine++;
        }

        this.RecalculateCurPos();
        this.CurPos.RealX = this.CurPos.X;
        this.CurPos.RealY = this.CurPos.Y;

        if ( this.Lines.length - 1 == CurLine )
        {
            // TODO: надо перейти в предыдущий элемент документы

            this.Selection.EndPos = this.Content.length - 1;
        }
        else
        {
            this.Cursor_MoveAt( this.CurPos.RealX, CurLine + 1, true, true );
            this.CurPos.RealY = this.CurPos.Y;
            this.Selection.EndPos = this.CurPos.ContentPos;
        }

        if ( this.Selection.StartPos == this.Selection.EndPos )
        {
            this.Selection_Remove();
            this.Selection.Use = false;

            this.CurPos.ContentPos = this.Selection.EndPos;
            this.RecalculateCurPos();

            // После перемещения курсора мы должны обновить запись о шрифте
            var TextPr = this.Internal_CalculateTextPr( this.CurPos.ContentPos );
            Interface.UpdateTextPr( TextPr );
            // Возвращаем курсор
            Target.Drawing_Init();

            return;
        }

        // Убираем курсор
        Target.Drawing_Remove();

        this.Selection_CalculateTextPr();
        this.Selection_Draw();
    }
    else
    {
        if ( this.Lines.length - 1 == CurLine )
        {
            // TODO: надо перейти в следующий элемент документы
        }
        else
        {
            this.Cursor_MoveAt( this.CurPos.RealX, CurLine + 1, true, true );
            this.CurPos.RealY = this.CurPos.Y;
        }
    }
}
CParagraph.prototype.Cursor_MoveEndOfLine = function(AddToSelect)
{
	if ( this.CurPos.ContentPos < 0 )
		return false;

    if ( true === this.Selection.Use )
    {
        if ( true === AddToSelect )
            this.CurPos.ContentPos = this.Selection.EndPos;
        else
            this.Selection_Remove();
    }
	
	var oPos = this.Internal_FindForward( this.CurPos.ContentPos, [para_NewLine, para_NewLineRendered, para_End] );


    if ( true === this.Selection.Use && true === AddToSelect )
    {
        if ( oPos.Found )
        {
            this.Selection.EndPos = oPos.LetterPos;

            if ( this.Selection.StartPos == this.Selection.EndPos )
            {
                this.Selection_Remove();
                this.Selection.Use = false;

                this.CurPos.ContentPos = this.Selection.EndPos;
                this.RecalculateCurPos();

                // После перемещения курсора мы должны обновить запись о шрифте
                var TextPr = this.Internal_CalculateTextPr( this.CurPos.ContentPos );
                Interface.UpdateTextPr( TextPr );
                // Возвращаем курсор
                Target.Drawing_Init();

                return;
            }

            // Убираем курсор
            Target.Drawing_Remove();

            this.Selection_CalculateTextPr();
            this.Selection_Draw();
        }
    }
    else if ( AddToSelect )
    {
        if ( oPos.Found )
        {
            this.Selection.StartPos = this.CurPos.ContentPos;
            this.Selection.Use      = true;

            this.Selection.EndPos = oPos.LetterPos;

            if ( this.Selection.StartPos == this.Selection.EndPos )
            {
                this.Selection_Remove();
                this.Selection.Use = false;

                this.CurPos.ContentPos = this.Selection.EndPos;
                this.RecalculateCurPos();

                // После перемещения курсора мы должны обновить запись о шрифте
                var TextPr = this.Internal_CalculateTextPr( this.CurPos.ContentPos );
                Interface.UpdateTextPr( TextPr );
                // Возвращаем курсор
                Target.Drawing_Init();

                return;
            }

            // Убираем курсор
            Target.Drawing_Remove();

            this.Selection_CalculateTextPr();
            this.Selection_Draw();
        }
    }
    else
    {
        if ( oPos.Found )
        {
            this.CurPos.ContentPos = oPos.LetterPos;
        }

        // После перемещения курсора мы должны обновить запись о шрифте
        var TextPr = this.Internal_CalculateTextPr( this.CurPos.ContentPos );
        Interface.UpdateTextPr( TextPr );

        this.RecalculateCurPos();
        this.CurPos.RealX = this.CurPos.X;
        this.CurPos.RealY = this.CurPos.Y;
    }
}
CParagraph.prototype.Cursor_MoveStartOfLine = function(AddToSelect)
{
	if ( this.CurPos.ContentPos < 0 )
		return false;

    if ( true === this.Selection.Use )
    {
        if ( true === AddToSelect )
            this.CurPos.ContentPos = this.Selection.EndPos;
        else
            this.Selection_Remove();
    }

	// Начинаем искать с предыдущей позиции, потому что текущая может сама быть переносом строки
	var oPos = this.Internal_FindBackward( this.CurPos.ContentPos - 1, [para_NewLine, para_NewLineRendered] );


    if ( true === this.Selection.Use && true === AddToSelect )
    {
        if ( oPos.Found )
            this.Selection.EndPos = oPos.LetterPos + 1;
        else
            this.Selection.EndPos = 0;

        if ( this.Selection.StartPos == this.Selection.EndPos )
        {
            this.Selection_Remove();
            this.Selection.Use = false;

            this.CurPos.ContentPos = this.Selection.EndPos;
            this.RecalculateCurPos();

            // После перемещения курсора мы должны обновить запись о шрифте
            var TextPr = this.Internal_CalculateTextPr( this.CurPos.ContentPos );
            Interface.UpdateTextPr( TextPr );
            // Возвращаем курсор
            Target.Drawing_Init();

            return;
        }

        // Убираем курсор
        Target.Drawing_Remove();

        this.Selection_CalculateTextPr();
        this.Selection_Draw();
    }
    else if ( AddToSelect )
    {
        if ( oPos.Found )
            this.Selection.EndPos = oPos.LetterPos + 1;
        else
            this.Selection.EndPos = 0;

        this.Selection.StartPos = this.CurPos.ContentPos;
        this.Selection.Use      = true;

        if ( this.Selection.StartPos == this.Selection.EndPos )
        {
            this.Selection_Remove();
            this.Selection.Use = false;

            this.CurPos.ContentPos = this.Selection.EndPos;
            this.RecalculateCurPos();

            // После перемещения курсора мы должны обновить запись о шрифте
            var TextPr = this.Internal_CalculateTextPr( this.CurPos.ContentPos );
            Interface.UpdateTextPr( TextPr );
            // Возвращаем курсор
            Target.Drawing_Init();

            return;
        }

        // Убираем курсор
        Target.Drawing_Remove();

        this.Selection_CalculateTextPr();
        this.Selection_Draw();
    }
    else
    {
        if ( oPos.Found )
        {
            this.CurPos.ContentPos = oPos.LetterPos + 1; // Чтобы встать на следующую линию
        }
        else
        {
            this.CurPos.ContentPos = 0;
        }

        // После перемещения курсора мы должны обновить запись о шрифте
        var TextPr = this.Internal_CalculateTextPr( this.CurPos.ContentPos );
        Interface.UpdateTextPr( TextPr );

        this.RecalculateCurPos();
        this.CurPos.RealX = this.CurPos.X;
        this.CurPos.RealY = this.CurPos.Y;

    }
}
CParagraph.prototype.Internal_MoveCursorBackward = function (AddToSelect)
{
    if ( true === this.Selection.Use )
    {
        if ( true === AddToSelect )
        {
            this.CurPos.ContentPos = this.Selection.EndPos;
        }
        else
        {
            // В случае селекта, убираем селект и перемещаем курсор в начало селекта
            var StartPos = this.Selection.StartPos;
            var EndPos   = this.Selection.EndPos;

            if ( StartPos > EndPos )
            {
                var Temp = EndPos;
                EndPos   = StartPos;
                StartPos = Temp;
            }

            this.Selection_Remove();
            this.CurPos.ContentPos = StartPos;
            return;
        }
    }

	var oPos = this.Internal_FindBackward( this.CurPos.ContentPos - 1, [para_Text, para_Space, para_NewLine, para_NewLineRendered] );

	/*
	var oPos2 = new Object();
	LetterPos = oPos.LetterPos - 1;
	oPos2 = this.Internal_FindBackward( LetterPos, [para_Letter, para_Space, para_NewLine, para_NewLineCalc] );
	
	if ( oPos2.Found && oPos2.Type != para_NewLineCalc )
	{
		this.Content.splice( oPos2.LetterPos + 1, 0, { Value : 0, Type : para_Cur } );
	}
	else
	{
		if ( oPos.Found )
		{
			this.Content.splice( oPos.LetterPos, 0, { Value : 0, Type : para_Cur } );
		}
		else
		{
			// Восстанавливаем текущую позицию
			Line.splice( nCurPos, 0, { Value : 0, Type : para_Cur } );
		}
	}
	*/

    if ( true === this.Selection.Use ) // Добавляем к селекту
    {
        if ( oPos.Found )
        {
            this.Selection.EndPos = oPos.LetterPos;

            if ( this.Selection.StartPos == this.Selection.EndPos )
            {
                this.Selection_Remove();
                this.Selection.Use = false;

                this.CurPos.ContentPos = this.Selection.EndPos;
                this.RecalculateCurPos();

                // После перемещения курсора мы должны обновить запись о шрифте
                var TextPr = this.Internal_CalculateTextPr( this.CurPos.ContentPos );
                Interface.UpdateTextPr( TextPr );
                // Возвращаем курсор
                Target.Drawing_Init();

                return;
            }
            else
            {
                // Убираем курсор
                Target.Drawing_Remove();
                
                this.Selection_CalculateTextPr();
                this.Selection_Draw();
            }

            return true;
        }
        else
        {
            // TODO: Надо перейти в предыдущий элемент документа
            return false;
        }

    }
    else if ( true == AddToSelect )
    {
        // Селекта еще нет, добавляем с текущей позиции
        this.Selection.StartPos = this.CurPos.ContentPos;
        this.Selection.Use      = true;

        if ( oPos.Found )
        {
            this.Selection.EndPos = oPos.LetterPos;

            // Убираем курсор
            Target.Drawing_Remove();
            
            this.Selection_CalculateTextPr();
            this.Selection_Draw();

            return true;
        }
        else
        {
            this.Selection.Use = false;
            // TODO: Надо перейти в предыдущий элемент документа
            return false;
        }
    }
    else
    {
        if ( oPos.Found )
        {
            this.CurPos.ContentPos = oPos.LetterPos;
            return true;
        }
        else
        {
            // Надо перейти в предыдущий элемент документа
            return false;
        }

    }
}
CParagraph.prototype.Internal_MoveCursorForward  = function (AddToSelect)
{
    if ( true === this.Selection.Use )
    {
        if ( true === AddToSelect )
        {
            this.CurPos.ContentPos = this.Selection.EndPos;
        }
        else
        {
            // В случае селекта, убираем селект и перемещаем курсор в конец селекта
            var StartPos = this.Selection.StartPos;
            var EndPos   = this.Selection.EndPos;

            if ( StartPos > EndPos )
            {
                var Temp = EndPos;
                EndPos   = StartPos;
                StartPos = Temp;
            }

            this.Selection_Remove();
            this.CurPos.ContentPos = EndPos;
            return;
        }
    }

	var oPos = this.Internal_FindForward( this.CurPos.ContentPos + 1, [para_Text, para_Space, para_NewLine, para_NewLineRendered, para_End] );


    if ( true == this.Selection.Use && true == AddToSelect )
    {
        this.Selection.EndPos = oPos.LetterPos;

        if ( this.Selection.StartPos == this.Selection.EndPos )
        {
            this.Selection_Remove();
            this.Selection.Use = false;

            this.CurPos.ContentPos = this.Selection.EndPos;
            this.RecalculateCurPos();

            // После перемещения курсора мы должны обновить запись о шрифте
            var TextPr = this.Internal_CalculateTextPr( this.CurPos.ContentPos );
            Interface.UpdateTextPr( TextPr );
            // Возвращаем курсор
            Target.Drawing_Init();

            return;
        }
        else
        {
            // Убираем курсор
            Target.Drawing_Remove();

            this.Selection_CalculateTextPr();
            this.Selection_Draw();
        }

        return true;
    }
    else if ( true == AddToSelect )
    {
        // Селекта еще нет, добавляем с текущей позиции
        this.Selection.StartPos = this.CurPos.ContentPos;
        this.Selection.Use      = true;

        if ( oPos.Found )
        {
            this.Selection.EndPos = oPos.LetterPos;

            // Убираем курсор
            Target.Drawing_Remove();

            this.Selection_CalculateTextPr();
            this.Selection_Draw();

            return true;
        }
        else
        {
            this.Selection.Use = false;
            // TODO: Надо перейти в предыдущий элемент документа
            return false;
        }
    }
    else
    {
        if ( oPos.Found )
        {
            this.CurPos.ContentPos = oPos.LetterPos;
            return true;
        }
        else
        {
            // TODO: Надо перейти в следующий элемент документа
            return false;
        }

    }
}
CParagraph.prototype.Internal_AddTextPr = function(TextPr)
{
	// найдем текущую позицию
	var Line   = this.Content;
	var CurPos = this.CurPos.ContentPos;
	if ( true === this.Selection.Use )
	{
		var StartPos = this.Selection.StartPos;
		var EndPos   = this.Selection.EndPos;
		
		if ( StartPos > EndPos )
		{
			var Temp = EndPos;
			EndPos   = StartPos;
			StartPos = Temp;
			this.Selection.StartPos = StartPos;
			this.Selection.EndPos   = EndPos;
		}
		
		// Рассчитываем шрифт, который используется после слова
		var oldTextPr = this.Internal_CalculateTextPr( EndPos );
		
		this.Content.splice( StartPos, 0, new ParaTextPr( TextPr ) );
		this.Content.splice( EndPos + 2 /* из-за предыдущего splice */, 0, new ParaTextPr( oldTextPr ) );
		this.Selection.EndPos += 2;
		
		// Если внутри слова были изменения текстовых настроек, тогда удаляем только те записи, которые
		// меняются сейчас. Например, у нас изменен только размер шрифта, то удаляем запись о размере шрифта.
		for ( var Pos = StartPos + 1; Pos < EndPos; Pos++ )
		{
			if ( this.Content[Pos].Type == para_TextPr )
			{
				for ( var Item in this.Content[Pos].Value )
				{
					if ( "undefined" != typeof(TextPr[Item]) )
						delete this.Content[Pos].Value[Item];
				}
			}
		}
		this.Recalculate();
		this.Draw();
		
		this.Selection_Draw();
		Interface.UpdateTextPr( TextPr );
		return;
	}

	
	// При изменении шрифта ведем себе следующим образом:
	// 1. Если мы в конце параграфа, тогда добавляем запись о шрифте (применимо к знаку конца параграфа)
	// 2. Если справа или слева стоит пробел (начало параграфа или перенос строки(командный)), тогда ставим метку со шрифтом и фокусим канву.
	// 3. Если мы посередине слова, тогда меняем шрифт для данного слова

	var oEnd   = this.Internal_FindForward ( CurPos, [para_Text, para_Space, para_End, para_NewLine] );
	var oStart = this.Internal_FindBackward( CurPos - 1, [para_Text, para_Space, para_NewLine] );
	var CurType = this.Content[CurPos].Type;
	
	if ( !oEnd.Found )
		return;
	
	if ( para_End == oEnd.Type )
	{
		// Вставляем запись о новых настройках перед концом параграфа, а текущую позицию выставляем на конец параграфа
		var Pos = oEnd.LetterPos;
		this.Content.splice( Pos, 0, new ParaTextPr( TextPr ) );
		this.CurPos.ContentPos = Pos + 1;
		this.Draw();
	}
	else if ( para_Space == CurType || para_NewLine == CurType || !oStart.Found || para_NewLine == oEnd.Type || para_Space == oEnd.Type || para_NewLine == oStart.Type || para_Space == oStart.Type )
	{
		var oldTextPr = this.Internal_CalculateTextPr( CurPos );
		this.Content.splice( CurPos, 0, new ParaTextPr( TextPr ), new ParaTextPr( oldTextPr ) );
		this.CurPos.ContentPos = CurPos + 1;
		this.RecalculateCurPos();
	}
	else
	{
		// Мы находимся посередине слова. В начале слова ставим запись о новом шрифте,
		// а в конце слова старый шрифт. Кроме этого, надо удалить все записи о шрифте внутри слова.
		
		// Найдем начало слова
		var oWordStart = this.Internal_FindBackward( CurPos, [para_Space, para_NewLine] );
		if ( !oWordStart.Found )
			oWordStart = this.Internal_FindForward( 0, [para_Text] );
		else
			oWordStart.LetterPos++;
		
		var oWordEnd   = this.Internal_FindForward( CurPos, [para_Space, para_End, para_NewLine] );
		
		if ( !oWordStart.Found || !oWordEnd.Found )
			return;
		
		// Рассчитываем шрифт, который используется после слова
		var oldTextPr = this.Internal_CalculateTextPr( oWordEnd.LetterPos );
		
		this.Content.splice( oWordStart.LetterPos, 0, new ParaTextPr( TextPr ) );
		this.Content.splice( oWordEnd.LetterPos + 1 /* из-за предыдущего splice */, 0, new ParaTextPr( oldTextPr ) );
		this.CurPos.ContentPos = CurPos + 1;
		
		// Если внутри слова были изменения текстовых настроек, тогда удаляем только те записи, которые
		// меняются сейчас. Например, у нас изменен только размер шрифта, то удаляем запись о размере шрифта.
		for ( var Pos = oWordStart.LetterPos + 1; Pos < oWordEnd.LetterPos; Pos++ )
		{
			if ( this.Content[Pos].Type == para_TextPr )
			{
				for ( var Item in this.Content[Pos].Value )
				{
					if ( "undefined" != typeof(TextPr[Item]) )
						delete this.Content[Pos].Value[Item];
				}
			}
		}
		this.Recalculate();
		this.Draw();
	}
	Interface.UpdateTextPr(TextPr);
}
CParagraph.prototype.GetContentPosByXY = function(X,Y, bLine)
{
	var Line   = this.Content;
	
	// Сначала определим на какую строку мы попали
	var bFindY   = false;
	var CurLine  = 0;
	var CurLineY = this.Y;
	
	if ( true === bLine )
		CurLine = Y;
	else
	{
		while ( !bFindY )
		{
			if ( Y < CurLineY )
				break;
			if ( CurLine == this.Lines.length - 1 )
				break;
			
			CurLine++;
			CurLineY = this.Lines[CurLine].Y + this.Y;
		}
	}
	
	var CurTextPr = 
	{
		Bold       : Default_TextPr_Bold,
		Italic     : Default_TextPr_Italic,
		Underline  : Default_TextPr_Underline,
		Strikeout  : Default_TextPr_Strikeout,
		FontFamily : Default_TextPr_FontFamily,
		FontSize   : Default_TextPr_FontSize,
	};
	
	Canvas.SetFont( CurTextPr );
	
	// Ищем позицию в строке
	var CurLine2 = 0;
	
	var CurX = 0;
	var JustifySpace = 0;
	var bCalc = false;
	var ItemNum = 0;
	var bEOL = false;
	var DiffX = this.XLimit;
	var DiffPos = -1;
	for ( ItemNum = 0; ItemNum < this.Content.length; ItemNum++ )
	{
		var Item = this.Content[ItemNum];
		
		if ( CurLine == CurLine2 )
		{
			if ( !bCalc )
			{
				bCalc = true;
				bWord = false;
				var LineWidth = this.XLimit - this.X;
				switch (this.Pr.Jc)
				{
					case align_Left   : CurX = this.X; break;
					case align_Right  : CurX = this.X + LineWidth - this.Lines[CurLine].W; break;
					case align_Center : CurX = this.X + (LineWidth - this.Lines[CurLine].W) / 2; break
					case align_Justify:
					{
						CurX = this.X; 
						if ( this.Lines[CurLine].Words > 1 )
							JustifySpace = (LineWidth - this.Lines[CurLine].W) / ( this.Lines[CurLine].Words - 1); 
						else
							JustifySpace = 0;
						break;
					}
				}
				nWords = this.Lines[CurLine].Words - 1;
			}
			
			var TempDx = 0;
			var bCheck = false;
			switch( Item.Type )
			{
				case para_Text:
					if ( !bWord )
						bWord = true;
					TempDx = Item.Width;
					bCheck = true;
				break;
				case para_Space:
					if ( bWord )
					{
						bWord = false;
						if ( nWords > 0 )
						{
							CurX += JustifySpace;
							nWords--;
						}
					}
					TempDx = Item.Width;
					bCheck = true;
					break;
				case para_SetFont:
					
					for (var Prop in Item.Value)
					{
						CurTextPr[Prop] = Item.Value[Prop];
					}
					Canvas.SetFont( CurTextPr );
					break;
					
				case para_NewLine:
				case para_NewLineRendered:
				case para_End:
					bEOL = true;
					bCheck = true;
					break;
			}
			
			if ( bCheck )
			{
				if ( Math.abs( X - CurX ) < DiffX )
				{
					DiffX = Math.abs( X - CurX );
					DiffPos = ItemNum;
				}
				
				if ( bEOL )
					break;
			}
			CurX += TempDx;

		}
		else
		{
			if ( Item.Type == para_NewLine || Item.Type == para_NewLineRendered )
				CurLine2++;
			else if ( Item.Type == para_TextPr )
			{
				for (var Prop in Item.Value)
				{
					CurTextPr[Prop] = Item.Value[Prop];
				}
				Canvas.SetFont( CurTextPr );
			}
		}
	}
	
	return DiffPos;
}
CParagraph.prototype.GetXYByContentPos = function(Pos)
{
    var CurTextPr =
    {
        Bold       : Default_TextPr_Bold,
        Italic     : Default_TextPr_Italic,
        Underline  : Default_TextPr_Underline,
        Strikeout  : Default_TextPr_Strikeout,
        FontFamily : Default_TextPr_FontFamily,
        FontSize   : Default_TextPr_FontSize,
    };

    Canvas.SetFont( CurTextPr );

    var Y = this.Y;
    var CurLine = 0;
    var LineWidth = this.XLimit - this.X;

    var X = 0;
    var JustifySpace = 0;

    switch (this.Pr.Jc)
    {
        case align_Left   : X = this.X; break;
        case align_Right  : X = this.X + LineWidth - this.Lines[0].W; break;
        case align_Center : X = this.X + (LineWidth - this.Lines[0].W) / 2; break
        case align_Justify:
        {
            X = this.X;
            if ( this.Lines[0].Words > 1 )
                JustifySpace = (LineWidth - this.Lines[0].W) / ( this.Lines[0].Words - 1);
            else
                JustifySpace = 0;
            break;
        }
        default : X = this.X; break;
    }

    var bWord = false;
    var nWords = this.Lines[0].Words - 1;

    for ( var ItemNum = 0; ItemNum < this.Content.length; ItemNum++ )
    {
        if ( ItemNum == Pos )
            return { X : X, Y : Y };

        var Item = this.Content[ItemNum];

        switch( Item.Type )
        {
            case para_Text:
                if ( !bWord )
                    bWord = true;
                X += Item.Width;
                break;
            case para_Space:
                if ( bWord )
                {
                    bWord = false;
                    if ( nWords > 0 )
                    {
                        X += JustifySpace;
                        nWords--;
                    }
                }
                X += Item.Width;
                break;
            case para_TextPr:

                for (var Prop in Item.Value)
                {
                    CurTextPr[Prop] = Item.Value[Prop];
                }
                Canvas.SetFont( CurTextPr );
                break;

            case para_End:
                X += Item.Width;
                break;
            case para_NewLine:

                X += Item.Width;

            // break специально не ставим
            case para_NewLineRendered:

                Y += (0.23 * this.Lines[CurLine].H / 1.3 + this.Lines[CurLine + 1].H / 1.3) * this.Pr.Spacing.Line;

                CurLine++;
                Y = this.Y + this.Lines[CurLine].Y;
                bWord = false;
                switch (this.Pr.Jc)
                {
                    case align_Left   : X = this.X; break;
                    case align_Right  : X = this.X + LineWidth - this.Lines[CurLine].W; break;
                    case align_Center : X = this.X + (LineWidth - this.Lines[CurLine].W) / 2; break
                    case align_Justify:
                    {
                        X = this.X;
                        if ( this.Lines[CurLine].Words > 1 )
                            JustifySpace = (LineWidth - this.Lines[CurLine].W) / ( this.Lines[CurLine].Words - 1);
                        else
                            JustifySpace = 0;
                        break;
                    }
                }
                nWords = this.Lines[CurLine].Words - 1;
                break;
        }
        if ( Y > 842 )
            break;
    }

    return { X : -1, Y : -1 };
}
CParagraph.prototype.Cursor_MoveAt = function(X,Y, bLine, bDontChangeRealPos)
{
	var Pos = this.GetContentPosByXY( X, Y, bLine );
	
	if ( -1 != Pos )
		this.CurPos.ContentPos = Pos;
	
	// После перемещения курсора мы должны обновить запись о шрифте
	var TextPr = this.Internal_CalculateTextPr( this.CurPos.ContentPos );
	Interface.UpdateTextPr( TextPr );
	
	this.RecalculateCurPos();
	
	if ( bDontChangeRealPos != true )
	{
		this.CurPos.RealX = this.CurPos.X;
		this.CurPos.RealY = this.CurPos.Y;
	}
}
CParagraph.prototype.Selection_SetStart = function(X,Y)
{
	var Pos = this.GetContentPosByXY( X, Y );
	if ( -1 != Pos )
	{
		this.Selection.StartPos = Pos;
		this.Selection.Use      = true;
		this.Selection.Start    = true;
    }
}

// Данная функция может использоваться как при движении, так и при окончательном выставлении селекта.
// Если bEnd = true, тогда это конец селекта.
CParagraph.prototype.Selection_SetEnd = function(X,Y, bEnd)
{
	var Pos = this.GetContentPosByXY( X, Y );
	if ( -1 != Pos )
	{
		this.Selection.EndPos = Pos;
		if ( this.Selection.EndPos == this.Selection.StartPos && true === bEnd )
		{
            var Temp = ClickCount % 2;

            if ( 1 == ClickCount )
            {
                this.Selection_Remove();
                this.Selection.Use = false;

                this.CurPos.ContentPos = Pos;
                this.RecalculateCurPos();

                // После перемещения курсора мы должны обновить запись о шрифте
                var TextPr = this.Internal_CalculateTextPr( this.CurPos.ContentPos );
                Interface.UpdateTextPr( TextPr );
                // Возвращаем курсор
                Target.Drawing_Init();

                return;
            }
            else if ( 0 == Temp )
            {
                var oStart;
                if ( this.Content[Pos].Type == para_Space )
                {
                    oStart = this.Internal_FindBackward( Pos, [ para_Text, para_NewLine ] );
                    if ( !oStart.Found )
                        oStart.LetterPos = 0;
                    else if ( oStart.Type == para_NewLine )
                    {
                        oStart.LetterPos++; // смещаемся на начало следующей строки
                    }
                    else
                    {
                        oStart = this.Internal_FindBackward( oStart.LetterPos, [ para_Space, para_NewLine ] );
                        if ( !oStart.Found )
                            oStart.LetterPos = 0;
                        else
                        {
                            oStart = this.Internal_FindForward( oStart.LetterPos, [ para_Text ] );
                            if ( !oStart.Found )
                                oStart.LetterPos = 0;
                        }
                    }
                }
                else
                {
                    var oStart = this.Internal_FindBackward( Pos, [ para_Space, para_NewLine ] );
                    if ( !oStart.Found )
                        oStart.LetterPos = 0;
                    else
                    {
                        oStart = this.Internal_FindForward( oStart.LetterPos, [ para_Text, para_NewLine ] );
                        if ( !oStart.Found )
                            oStart.LetterPos = 0;
                    }
                }

                var oEnd = this.Internal_FindForward( Pos, [ para_Space, para_NewLine ] );
                if ( !oEnd.Found )
                    oEnd.LetterPos = this.Content.length - 1;
                else if ( oEnd.Type != para_NewLine ) // при переносе строки селектим все до переноса строки
                {
                    oEnd = this.Internal_FindForward( oEnd.LetterPos, [ para_Text ] );
                    if ( !oEnd.Found )
                        oEnd.LetterPos = this.Content.length - 1;
                }
                Para.Selection.StartPos = oStart.LetterPos;
                Para.Selection.EndPos   = oEnd.LetterPos;
                Para.Selection.Use = true;
            }
            else // ( 1 == ClickCount % 3 )
            {
                // Селектим параграф целиком
                Para.Selection.StartPos = 0;
                Para.Selection.EndPos = Para.Content.length - 1;
                Para.Selection.Use = true;
            }

            // Убираем курсор
            Target.Drawing_Remove();
		}
		else
		{
			// Убираем курсор
			Target.Drawing_Remove();
		}
	}
	
	if ( true === this.Selection.Use )
	{
		this.Selection_CalculateTextPr();
		this.Selection_Draw();
	}
}

CParagraph.prototype.Selection_Remove = function()
{
	this.Selection.Use = false;
	
	this.Selection_Clear();
	// Возвращаем курсор
	Target.Drawing_Init();

    Interface.FlyTextPr_Remove();
}
CParagraph.prototype.Selection_Clear = function()
{
	// Удаляем весь селект
	for ( var Index = 0; Index < this.Selection.SelectIds.length; Index++ )
	{
		var Div = document.getElementById(this.Selection.SelectIds[Index]);
		document.body.removeChild(Div);
	}
	this.Selection.SelectIds.length = 0;
}
CParagraph.prototype.Selection_Draw = function(bNClear)
{
	if ( true === this.Selection.Use )
	{
		// Делаем подсветку
		var StartPos = this.Selection.StartPos;
		var EndPos   = this.Selection.EndPos;
		
		if ( StartPos > EndPos )
		{
			var Temp = EndPos;
			EndPos   = StartPos;
			StartPos = Temp;
		}
		
		// Найдем линию, с которой начинается селект, и посчитаем начальный сдвиг
		var CurLine = 0;
		var StartX = this.X;
		for ( var Pos = StartPos - 1; Pos >= 0; Pos-- )
		{
			var Item = this.Content[Pos];
			if ( Item.Type == para_NewLine || Item.Type == para_NewLineRendered )
				CurLine++;
			
			if ( 0 == CurLine )
			{
				if ( "undefined" != typeof(Item.Width) )
					StartX += Item.Width;
			}
		}
		
		var StartY = this.Y + this.Lines[CurLine].Y - (this.Lines[CurLine].H / 1.3)*this.Pr.Spacing.Line - 1;
		
		var H = (0.23 * this.Lines[CurLine].H / 1.3 + this.Lines[CurLine].H / 1.3) * this.Pr.Spacing.Line;
		var W = 0;

        var TempSelectIds = new Array();
		for ( var Pos = StartPos; Pos <= EndPos; Pos++ )
		{
			var Item = this.Content[Pos];
			if ( Item.Type == para_NewLine || Item.Type == para_NewLineRendered || Pos == EndPos )
			{
				var Div = document.createElement("div");
				Div.id                    = "" + Pos;
				Div.style.position        = "absolute";
				Div.style.backgroundColor = "#36C";
				Div.style.borderTop       = "0px solid #36C";
				Div.style.borderBottom    = "0px solid #36C";
				Div.style.opacity         = 0.20;
				Div.style["-moz-opacity"] = 0.20;
				Div.style.filter          = "alpha(opacity=20)";
				Div.style.zIndex          = 20;
				Div.style.top             = StartY + 70 + 0.5;
				Div.style.left            = StartX + 50;
				Div.style.width           = W;
				Div.style.height          = H + 0.5;
				Div.style.cursor          = "Text";
                Div.tabIndex              = 1;

                Div.onfocus      = new Function("Canvas.Focus(); FocusCanv = true;");
				Div.onclick      = new Function("e", "if (!e) e = event; Actions_CanvasClick(e);");
				Div.onmousemove  = new Function("e", "if (!e) e = event; Actions_CanvasOnMove(e);");
				Div.onmouseup    = new Function("e", "if (!e) e = event; Actions_CanvasMouseUp(e);");
                Div.onmousedown  = new Function("e", "if (!e) e = event; Actions_CanvasMouseDown(e);");

				document.body.appendChild( Div );
                TempSelectIds.push( Div.id );

				CurLine++;
				if ( CurLine < this.Lines.length )
				{
					StartX = this.X;
					StartY = this.Y + this.Lines[CurLine].Y - (this.Lines[CurLine].H / 1.3)*this.Pr.Spacing.Line - 1;
		
					H = (0.23 * this.Lines[CurLine].H / 1.3 + this.Lines[CurLine].H / 1.3) * this.Pr.Spacing.Line;
					W = 0;
				}
			}
			else
			{
				if ( "undefined" != typeof(Item.Width) )
					W += Item.Width;
			}
		}

        this.Selection_Clear();
        for ( var Index = 0; Index < TempSelectIds.length; Index++ )
            this.Selection.SelectIds.push( TempSelectIds[Index] );
	}
}
CParagraph.prototype.Selection_CalculateTextPr = function()
{
	if ( true === this.Selection.Use )
	{
		var StartPos = this.Selection.StartPos;
		var EndPos   = this.Selection.EndPos;
		
		if ( StartPos > EndPos )
		{
			var Temp = EndPos;
			EndPos   = StartPos;
			StartPos = Temp;
		}
		
		if ( StartPos == EndPos )
			return this.Internal_CalculateTextPr( StartPos );
		
		while ( this.Content[StartPos].Type == para_TextPr )
			StartPos++;

		while ( this.Content[EndPos].Type == para_TextPr )
			EndPos--;
		
		// Рассчитаем стиль в начале селекта, и выставим его в интерфейсе
		var startTextPr = this.Internal_CalculateTextPr( StartPos );
		var VisTextPr = startTextPr;

		for ( var Pos = StartPos + 1; Pos < EndPos; Pos++ )
		{
			var Item = this.Content[Pos];
			if ( para_TextPr == Item.Type )
			{
				for ( var Pr in Item.Value )
				{
					if ( startTextPr[Pr] != Item.Value[Pr] )
					{
						switch(Pr)
						{
						case "Bold"      : VisTextPr.Bold       = false; break;
						case "Italic"    : VisTextPr.Italic     = false; break;
						case "Underline" : VisTextPr.Underline  = false; break;
						case "Strikeout" : VisTextPr.Strikeout  = false; break;
						case "FontSize"  : VisTextPr.FontSize   = "";    break;
						case "FontFamily": VisTextPr.FontFamily = "";    break;
						}
					}
				}
			}
		}
		
		Interface.UpdateTextPr( VisTextPr );
	}
}
